function chart_ranking_product (widget) {
    "use strict";

    var model = openerp;

    widget.ChartRankingProduct = widget.Base.extend({
        template: 'ChartRankingProduct',
        modules: ['point_of_sale'],
        data: [],

        events: {
            
        },

        init: function (parent) {
            this._super(parent, {
                width: 6,
                height: 4
            });
        },

        start: function () {
            var self = this;
            self.fetchInitial();
        },

        checkModel : function(model){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === model
            });
        },

        fetchInitial: function() {
            var self = this;
            self.fecthIrModuleModule().then(function (IrModuleModule) {
                return IrModuleModule;
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
                return self.fetchResUser();
            }).then(function(ResUser) {
                self.ResUser = ResUser;
                return self.fetchAccountJournal();
            }).then(function(AccountJournal) {
                self.AccountJournal = AccountJournal;
                return self.fecthPosOrder();
            }).then(function (PosOrder) {
                self.PosOrder = PosOrder;
                return self.fecthPosOrderLine();
            }).then(function (PosOrderLine) {
                self.PosOrderLine = PosOrderLine;
                return self.fetchAccountInvoice();
            }).then(function (AccountInvoice) {
                self.AccountInvoice = AccountInvoice;
                return self.fetchAccountInvoiceLine();
            }).then(function (AccountInvoiceLine) {
                self.AccountInvoiceLine = AccountInvoiceLine;
                return self.fecthProductProduct();
            }).then(function(ProductProduct){
                self.ProductProduct = ProductProduct;
                return self.fetchProductRanking();
            });
        },

        /* 
            IR MODULES
        */
       
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed'],['name','in',self.modules]];
            var IrModuleModule = new model.web.Model('ir.module.module');
            IrModuleModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            })                       
            return defer;
        },

        /* 
            USER
        */

        fetchResUser: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','store_id'];
            var domain = [['id','=',self.session.uid]];
            var ResUser = new model.web.Model('res.users');
            ResUser.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },

        fetchAccountJournal: function() {
            var self = this;
            var defer = $.Deferred();
            var store_ids = self.ResUser[0].store_id[0];
            var fields = ['id', 'name', 'store_ids'];
            var domain = [['type','=','sale'],['store_ids','in',store_ids]];
            var AccountJournal = new model.web.Model('account.journal');
            AccountJournal.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },
        
        fecthPosOrder: function() {
            var self = this;
            var defer = $.Deferred();
            var modules = self.checkModel('point_of_sale');
            if (modules.length > 0){
                var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                    return item.id;
                }));
                var date = moment().format('YYYY-MM-01 00:00:00');
                var fields = ['id', 'lines', 'date_order'];
                var domain = [['state', 'in', ['paid','done','invoiced']],['sale_journal','in',journal_ids],['date_order','>=',date]];
                var PosOrder = new model.web.Model('pos.order');
                PosOrder.query(fields).filter(domain).all().then(function (results) {
                    defer.resolve(results);
                });
                return defer;
            }else{
                var PosOrder = [];
                return PosOrder;
            }
        },

        fecthPosOrderLine: function() {
            var self = this;
            var defer = $.Deferred();
            var modules = self.checkModel('point_of_sale');
            if (modules.length > 0){
                var lines = _.flatten(_.map(self.PosOrder, function (item) {
                    return item.lines;
                }));
                var fields = ['id', 'product_id', 'qty','create_date'];
                var domain = [['id','in', lines]];
                var PosOrderLine = new model.web.Model('pos.order.line');
                PosOrderLine.query(fields).filter(domain).all().then(function (results) {
                    defer.resolve(results);
                });
                return defer;
            }else{
                var PosOrderLine = [];
                return PosOrderLine;
            }
        },

        fetchAccountInvoice: function() {
            var self = this;
            var defer = $.Deferred();
            var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                return item.id;
            }));
            var desde = moment().format('YYYY-MM-01');
            var hasta = moment().add(1,'months').format('YYYY-MM-01');
            var fields = ['id', 'invoice_line', 'date_invoice'];
            var domain = [['date_invoice', '>=', desde],['date_invoice', '<', hasta],['state', 'in', ['open','paid']],['journal_id','in',journal_ids],['type','=','out_invoice']];
            var AccountInvoice = new model.web.Model('account.invoice');
            AccountInvoice.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        fetchAccountInvoiceLine: function() {
            var self = this;
            var defer = $.Deferred();
            var invoice_line = _.flatten(_.map(self.AccountInvoice, function (item) {
                return item.invoice_line;
            }));
            var fields = ['id', 'product_id', 'quantity'];
            var domain = [['id','in', invoice_line]];
            var AccountInvoiceLine = new model.web.Model('account.invoice.line');
            AccountInvoiceLine.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        fecthProductProduct: function () {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id', 'name_template','attribute_str'];
            var domain = [['active', '=', true]];
            var ProductProduct = new model.web.Model('product.product');
            ProductProduct.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },

        getPosOrderLine: function (id) {
            var self = this;
            return _.flatten(_.filter(self.PosOrderLine,function (item) {
                var utc = moment.utc(item.create_date,'YYYY-MM-DD h:mm:ss A');
                return item.product_id[0] === id & moment(utc._d).format('YYYY-MM') === moment().format('YYYY-MM');
            }));
        },

        getAccountInvoiceLine: function (id) {
            var self = this;
            return _.flatten(_.filter(self.AccountInvoiceLine,function (item) {
                return item.product_id[0] === id;
            }));
        },
        
        fetchProductRanking: function() {
            var self = this;
            var PosOrderLine;
            var AccountInvoiceLine;
            var ranking = [];
            var attribute;
            for (var i = 0; i < self.ProductProduct.length; i++) {
                PosOrderLine = self.getPosOrderLine(self.ProductProduct[i].id);
                AccountInvoiceLine = self.getAccountInvoiceLine(self.ProductProduct[i].id);
                if (PosOrderLine.length > 0 || AccountInvoiceLine.length > 0) {
                    var pos_quantity = _.reduce(_.map(PosOrderLine, function (map) {
                        return map.qty
                    }), function (meno,num) {
                        return meno + num
                    }, 0);

                    var invoice_quantity = _.reduce(_.map(AccountInvoiceLine, function (map) {
                        return map.quantity
                    }), function (meno,num) {
                        return meno + num
                    }, 0);

                    var qty = pos_quantity + invoice_quantity;

                    if(self.ProductProduct[i].attribute_str){
                        attribute = '*' + self.ProductProduct[i].attribute_str;
                    }else{
                        attribute = ' ';
                    }
                    ranking.push({
                        id: self.ProductProduct[i].id,
                        product: self.ProductProduct[i].name_template + ' ' + attribute,
                        qty: qty,
                    });
                }
            }
            ranking.sort(function(a, b) {
                return b.qty - a.qty
            });
            self.fetchChart(ranking);
        },

        fetchChart: function (ranking){
            var self = this;
            var label = [];
            var body = [];
            var rank = 7;
            var item;

            for (var i = 0; i < rank; i++) {
                if (ranking[i]){
                    item = ranking[i];
                }else{
                    item = {};
                    item.product = "N/A";
                    item.qty = 0;
                }
                var name = item.product.split('*');
                if (name.length === 1) {
                        label.push(name[0]);
                }else{
                    label.push(name[0]+"("+name[name.length-1]+")");
                }
                body.push(item.qty);
            }

            var chart = new Chart(this.$el.find(".widget-content").find('canvas'), {
                type: 'horizontalBar',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: 'Productos ',
                            borderWidth: 1,
                            backgroundColor: '#bbdefb',
                            borderColor: '#0288d1',
                            data: body,
                            fill: true,
                        },
                    ]
                },
                options: {
                    responsive: true,
                    title: {
                        display: false,
                    },
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                       display: false,
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 40,
                            left: 0,
                            rigth: 0,
                        }
                    },
                    events: ['click'],
                }
            });
        },
        
    });
}
