function chart_ranking_salesman (widget) {
    "use strict";

    var model = openerp;

    widget.ChartRankingSalesman = widget.Base.extend({
        template: 'ChartRankingSalesman',
        modules: ['point_of_sale'],
        events: {
            
        },

        init: function (parent) {
            this._super(parent, {
                width: 6,
                height: 4
            });
        },

        start: function () {
            var self = this;
            self.fetchInitial();
        },

        checkModel : function(model){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === model
            });
        },

        fetchInitial:function() {
            var self = this;
            self.fecthIrModuleModule().then(function (IrModuleModule) {
                return IrModuleModule;
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
                return self.fetchResUser();
            }).then(function(ResUser) {
                self.ResUser = ResUser;
                return self.fetchAccountJournal();
            }).then(function(AccountJournal) {
                self.AccountJournal = AccountJournal;
                return self.fecthPosOrder();
            }).then(function (PosOrder) {
                self.PosOrder = PosOrder;
                return self.fetchAccountInvoice();
            }).then(function (AccountInvoice) {
                self.AccountInvoice = AccountInvoice;
                return self.fetchResCompany();
            }).then(function(ResCompany) {
                self.ResCompany = ResCompany;
                return self.fetchResCurrency();
            }).then(function(ResCurrency) {
                self.ResCurrency = ResCurrency;
                return self.fetchProductRanking();
            });
        },

        /* 
            IR MODULES
        */
       
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed'],['name','in',self.modules]];
            var IrModuleModule = new model.web.Model('ir.module.module');
            IrModuleModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            })                       
            return defer;
        },

        /* 
            USER
        */

        fetchResUser: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','store_id','company_id'];
            var domain = [['active','=',true]];
            var ResUser = new model.web.Model('res.users');
            ResUser.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },

        fetchAccountJournal: function() {
            var self = this;
            var defer = $.Deferred();
            var user = _.flatten(_.filter(self.ResUser,function (inv) {
                return inv.id === self.session.uid;
            }));
            var store_ids = user[0].store_id[0];
            var fields = ['id', 'name', 'store_ids'];
            var domain = [['type','=','sale'],['store_ids','in',store_ids]];
            var AccountJournal = new model.web.Model('account.journal');
            AccountJournal.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        fecthPosOrder: function() {
            var self = this;
            var defer = $.Deferred();
            var modules = self.checkModel('point_of_sale');
            if (modules.length > 0){
                var date = moment().add(-1, 'month').format('YYYY-MM-23 00:00:00');
                var fields = ['id','date_order','partner_id','amount_total','user_id'];
                var domain = [['state', 'in', ['paid','done','invoiced']],['date_order','>=',date]];
                var PosOrder = new model.web.Model('pos.order');
                PosOrder.query(fields).filter(domain).all().then(function (results) {
                    defer.resolve(results);
                });
                return defer;
            }else{
                var PosOrder = [];
                return PosOrder;
            }
        },

        fetchAccountInvoice: function() {
            var self = this;
            var defer = $.Deferred();
            var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                return item.id;
            }));
            var desde = moment().format('YYYY-MM-01');
            var hasta = moment().add(1,'months').format('YYYY-MM-01');
            var fields = ['id', 'invoice_line', 'date_invoice','user_id','amount_total','currency_id'];
            var domain = [['date_invoice', '>=', desde], ['date_invoice', '<', hasta],['state', 'in', ['open','paid']],['journal_id','in',journal_ids],['type','=','out_invoice']];
            var AccountInvoice = new model.web.Model('account.invoice');
            AccountInvoice.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        fetchResCompany: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name', 'currency_id'];
            var domain = [['id', '=', self.session.company_id]];
            var ResCompany = new model.web.Model('res.company');
            ResCompany.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        fetchResCurrency : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
            var domain = [['active', '=', true]];
            var ResCurrency = new model.web.Model('res.currency');
            ResCurrency.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        getResCurrency: function (id) {
            var self = this;
            return _.filter(self.ResCurrency,function (item) {
                return item.id === id;
            })
        },
       
        getPosOrder:function(id) {
            var self = this;
            return _.flatten(_.filter(self.PosOrder,function (inv) {
                var utc = moment.utc(inv.date_order,'YYYY-MM-DD h:mm:ss A');
                return inv.user_id[0] === id & moment(utc._d).format('YYYY-MM') === moment().format('YYYY-MM');
            }));
        },

        getAccountInvoice:function(id) {
            var self = this;
            return _.flatten(_.filter(self.AccountInvoice,function (inv) {
                return inv.user_id[0] === id;
            }));
        },

        fetchProductRanking: function() {
            var self = this;
            var PosOrder;
            var AccountInvoice;
            var ranking = [];
            var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            for (var i = 0; i < self.ResUser.length; i++) {
                var data = [];
                var pos_amount = 0;
                var invoice_amount = 0;
                PosOrder = self.getPosOrder(self.ResUser[i].id);
                AccountInvoice = self.getAccountInvoice(self.ResUser[i].id);
                if (PosOrder.length > 0 || AccountInvoice.length > 0) {
                    pos_amount = _.reduce(_.map(PosOrder,function(item) {
                        return item.amount_total;
                    }),function(memo, num) {
                        return memo + num;
                    },0);
                    _.each(AccountInvoice, function (item) {
                        var currency = self.getResCurrency(item.currency_id[0]).shift();
                        data.push({
                            amount: item.amount_total * (CurrencyBase.rate_silent / currency.rate_silent),
                        })
                    });
                    if(data.length > 0){
                        invoice_amount = _.reduce(_.map(data, function (map) {
                            return map.amount;
                        }), function (memo, num) {
                            return memo + num;
                        }); 
                    }
                    var amount = pos_amount + invoice_amount;
                    ranking.push({
                        id: self.ResUser[i].id,
                        name: self.ResUser[i].name,
                        amount: amount,
                    });
                }
            }
            ranking.sort(function (a, b) {
                return b.amount - a.amount
            });
            self.fetchChart(ranking);
        },

        fetchChart: function (ranking) {
            var self = this;
            var label = [];
            var body = [];
            var item;
            var rank = 7;

            if (ranking.length < rank && ranking.length > 0 )
                rank= ranking.length;

            for (var i = 0; i < rank; i++) {
                if (ranking[i]) {
                    item = ranking[i];
                }
                if (ranking.length === 0) {
                    item = {};
                    item.name = "N/A";
                    item.amount = 0;
                }
                label.push(item.name);
                body.push(item.amount);
            }
           
            Chart.scaleService.updateScaleDefaults('linear', {
              ticks: {
                callback: function(tick) {
                    return tick.toLocaleString('de-DE');
                }
              }
            });
            Chart.defaults.global.tooltips.callbacks.label = function(tooltipItem, data) {
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var datasetLabel = dataset.label || '';
                return datasetLabel +  dataset.data[tooltipItem.index].toLocaleString('de-DE');
            };
            var chart = new Chart(this.$el.find(".widget-content").find('canvas'), {
                type: 'horizontalBar',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: 'Ventas  ',
                            backgroundColor: '#bbdefb',
                            borderColor: '#0288d1',
                            borderWidth: 1,
                            data: body,
                        }
                    ]
                },
                options: {
                    responsive: true,
                    title: {
                        display: false,
                    },
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                       display: false,
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 40,
                            left: 0,
                            rigth: 0,
                        }
                    },
                    events: ['click'],
                    elements: {
                        line: {
                            tension: 0.000001
                        },
                    },
                }
            });
        },
    });
}
