function dashboard_reporting_widget (instance, widget) {
    "use strict";

    var widgets = widget;
    var InstalledModule = 0;
    

    widget.DashboardReportingWidget = instance.Widget.extend({
        template: 'DashboardReportingTemplate',
        widgets: [],
        grid: {},
        start: function () {
            this.$el.find('.grid-stack.reporting-dashboard').gridstack({
                animate: true,
            });
            this.grid = this.$el.find('.grid-stack.reporting-dashboard').data('gridstack');
            this.renderWidgets();
        },
        renderWidgets: function () { 
            var self = this;

            // *************************** Ventas
            var wUser = new widgets.UserWidget(self);
            wUser.fetchCurrentUser().then(function(CurrentUser){
                return CurrentUser;
            }).then(function(CurrentUser){
                wUser.fetchResUser(CurrentUser).then(function(chart_ids){
                    return chart_ids;
                }).then(function(chart_ids){
                    var charts = chart_ids[0].chart_ids;
                    wUser.fetchChartList(charts).then(function(ChartList){
                        return ChartList;
                    }).then(function(ChartList){
                        
                        // *************************** Ventas
                        var chart =  _.flatten(_.filter(ChartList,function (inv) {
                            return inv.name == 'WidgetSale';
                        }));
                        if(chart.length > 0){
                            var wWidgetSale = new widgets.WidgetSale(self);
                            wWidgetSale.renderElement();
                            wWidgetSale.start();
                            self.grid.addWidget(wWidgetSale.$el, 0, 0, wWidgetSale.size.width,  wWidgetSale.size.height, true);
                        }

                        // *************************** Compras
                        var chart =  _.flatten(_.filter(ChartList,function (inv) {
                            return inv.name == 'WidgetPurchase';
                        }));
                        if(chart.length > 0){
                            var wWidgetPurchase = new widgets.WidgetPurchaseWidget(self);
                            wWidgetPurchase.renderElement();
                            wWidgetPurchase.start();
                            self.grid.addWidget(wWidgetPurchase.$el, 0, 0, wWidgetPurchase.size.width,  wWidgetPurchase.size.height, true);
                        }

                        // *************************** Gastos
                        var chart =  _.flatten(_.filter(ChartList,function (inv) {
                            return inv.name == 'WidgetExpense';
                        }));
                        if(chart.length > 0){
                            var wWidgetExpense = new widgets.WidgetExpenseWidget(self);
                            wWidgetExpense.renderElement();
                            wWidgetExpense.start();
                            self.grid.addWidget(wWidgetExpense.$el, 0, 0, wWidgetExpense.size.width,  wWidgetExpense.size.height, true);
                        }

                        // *************************** Balance - [POSORDER - SALE]
                        var chart =  _.flatten(_.filter(ChartList,function (inv) {
                            return inv.name == 'WidgetBalance';
                        }));
                        if(chart.length > 0){
                            var wWidgetBalance = new widgets.WidgetBalanceWidget(self);
                            wWidgetBalance.renderElement();
                            wWidgetBalance.start();
                            self.grid.addWidget(wWidgetBalance.$el, 0, 0, wWidgetBalance.size.width,  wWidgetBalance.size.height, true);
                        }

                        // *************************** Ingreso Egreso
                        var chart =  _.flatten(_.filter(ChartList,function (inv) {
                            return inv.name == 'ChartIngresoEgreso';
                        }));
                        if(chart.length > 0){
                            var wChartIngresoEgreso = new widgets.ChartIngresoEgresoWidget(self);
                            wChartIngresoEgreso.renderElement();
                            wChartIngresoEgreso.start();
                            self.grid.addWidget(wChartIngresoEgreso.$el, 0, 0, wChartIngresoEgreso.size.width,  wChartIngresoEgreso.size.height, true);
                        }

                        // *************************** Ranking de clientes [POSORDER - SALE]
                        var chart =  _.flatten(_.filter(ChartList,function (inv) {
                            return inv.name == 'ChartRankingCustomer';
                        }));
                        if(chart.length > 0){
                            var wChartPosOrderCustomer = new widgets.ChartRankingCustomer(self);
                            wChartPosOrderCustomer.renderElement();
                            wChartPosOrderCustomer.start();
                            self.grid.addWidget(wChartPosOrderCustomer.$el, 0, 0, wChartPosOrderCustomer.size.width,  wChartPosOrderCustomer.size.height, true);
                        }

                        // *************************** Ranking de Productos [POSORDER - SALE]
                        var chart =  _.flatten(_.filter(ChartList,function (inv) {
                            return inv.name == 'ChartRankingProduct';
                        }));
                        if(chart.length > 0){
                            var wChartPosOrderProduct = new widgets.ChartRankingProduct(self);
                            wChartPosOrderProduct.renderElement();
                            wChartPosOrderProduct.start();
                            self.grid.addWidget(wChartPosOrderProduct.$el, 0, 0, wChartPosOrderProduct.size.width,  wChartPosOrderProduct.size.height, true);
                        }

                        // *************************** Vendedores [POSORDER - SALE]
                        var chart =  _.flatten(_.filter(ChartList,function (inv) {
                            return inv.name == 'ChartRankingSalesman';
                        }));
                        if(chart.length > 0){
                            var wChartPosOrderSalesman = new widgets.ChartRankingSalesman(self);
                            wChartPosOrderSalesman.renderElement();
                            wChartPosOrderSalesman.start();
                            self.grid.addWidget(wChartPosOrderSalesman.$el, 0, 0, wChartPosOrderSalesman.size.width,  wChartPosOrderSalesman.size.height, true);
                        }

                        // *************************** Ventas por Sucursal
                        var chart =  _.flatten(_.filter(ChartList,function (inv) {
                            return inv.name == 'ChartSaleByStore';
                        }));
                        if(chart.length > 0){
                            var wWidgetSaleByStore = new widgets.ChartSaleByStoreWidget(self);
                            wWidgetSaleByStore.renderElement();
                            wWidgetSaleByStore.start();
                            self.grid.addWidget(wWidgetSaleByStore.$el, 0, 0, wWidgetSaleByStore.size.width,  wWidgetSaleByStore.size.height, true);
                        }

                        // *************************** Caja Efectivo
                        var chart =  _.flatten(_.filter(ChartList,function (inv) {
                            return inv.name == 'WidgetCash';
                        }));
                        if(chart.length > 0){
                            var wWidgetCash = new widgets.WidgetCashWidget(self);
                            wWidgetCash.renderElement();
                            wWidgetCash.start();
                            self.grid.addWidget(wWidgetCash.$el, 0, 0, wWidgetCash.size.width,  wWidgetCash.size.height, true);
                        }

                        // *************************** Caja Banco
                        var chart =  _.flatten(_.filter(ChartList,function (inv) {
                            return inv.name == 'WidgetBank';
                        }));
                        if(chart.length > 0){
                            var wWidgetBank = new widgets.WidgetBankWidget(self);
                            wWidgetBank.renderElement();
                            wWidgetBank.start();
                            self.grid.addWidget(wWidgetBank.$el, 0, 0, wWidgetBank.size.width,  wWidgetBank.size.height, true);
                        }

                        // *************************** Cuentas a cobrar
                        var chart =  _.flatten(_.filter(ChartList,function (inv) {
                            return inv.name == 'WidgetAccountReceivable';
                        }));
                        if(chart.length > 0){
                            var wWidgetAccountReceivable = new widgets.WidgetAccountReceivableWidget(self);
                            wWidgetAccountReceivable.renderElement();
                            wWidgetAccountReceivable.start();
                            self.grid.addWidget(wWidgetAccountReceivable.$el, 0, 0, wWidgetAccountReceivable.size.width,  wWidgetAccountReceivable.size.height, true);
                        }

                        // *************************** Cuentas a pagar
                        var chart =  _.flatten(_.filter(ChartList,function (inv) {
                            return inv.name == 'WidgetAccountToPay';
                        }));
                        if(chart.length > 0){
                            var wWidgetAccountToPay = new widgets.WidgetAccountToPayWidget(self);
                            wWidgetAccountToPay.renderElement();
                            wWidgetAccountToPay.start();
                            self.grid.addWidget(wWidgetAccountToPay.$el, 0, 0, wWidgetAccountToPay.size.width,  wWidgetAccountToPay.size.height, true);
                        }
                    });
                });
            });
        }
    });
}
